package techreborn.api.recipe.recipes;

import net.minecraft.class_2338;
import net.minecraft.class_2586;
import net.minecraft.class_2960;
import net.minecraft.class_3611;
import net.minecraft.class_3612;
import reborncore.common.crafting.RebornFluidRecipe;
import reborncore.common.crafting.RebornRecipeType;
import reborncore.common.util.Tank;
import techreborn.blockentity.machine.multiblock.FluidReplicatorBlockEntity;
import techreborn.utils.FluidUtils;

public class FluidReplicatorRecipe extends RebornFluidRecipe {

	public FluidReplicatorRecipe(RebornRecipeType<?> type, class_2960 name) {
		super(type, name);
	}

	@Override
	public Tank getTank(class_2586 be) {
		FluidReplicatorBlockEntity blockEntity = (FluidReplicatorBlockEntity) be;
		return blockEntity.getTank();
	}

	@Override
	public boolean canCraft(class_2586 be) {
		FluidReplicatorBlockEntity blockEntity = (FluidReplicatorBlockEntity) be;
		if (!blockEntity.getMultiBlock()) {
			return false;
		}
		final class_2338 hole = blockEntity.method_11016().method_10079(blockEntity.getFacing().method_10153(), 2);
		final class_3611 fluid = techreborn.utils.FluidUtils.fluidFromBlock(blockEntity.method_10997().method_8320(hole).method_11614());
		if (fluid == class_3612.field_15906) {
			return true;
		}
		if (!FluidUtils.fluidEquals(fluid, getFluidInstance().getFluid())) {
			return false;
		}
		final class_3611 tankFluid = blockEntity.tank.getFluid();
		if (tankFluid != class_3612.field_15906 && !FluidUtils.fluidEquals(tankFluid, fluid)) {
			return false;
		}
		return blockEntity.tank.canFit(getFluidInstance().getFluid(), getFluidInstance().getAmount());
	}

	@Override
	public boolean onCraft(class_2586 be) {
		FluidReplicatorBlockEntity blockEntity = (FluidReplicatorBlockEntity) be;
		if (blockEntity.tank.canFit(getFluidInstance().getFluid(), getFluidInstance().getAmount())) {
			blockEntity.tank.setFluid(getFluidInstance().getFluid());
			blockEntity.tank.getFluidInstance().addAmount(getFluidInstance().getAmount());
		}
		return true;
	}
}
